// ------------------------------
// Filename      : cube.h
// Author        : Sven Maerivoet
// Last modified : 10/04/2001
// Target        : C++ (OpenGL)
//
// All rights reserved.
// ------------------------------

#ifndef SM_CUBE_H // include-guard
#define SM_CUBE_H

#include "opengl/opengl.h"
#include "opengl/primitives.h"
#include "opengl/rgbapixmap.h"
#include <vector>

using namespace std;

class CubeGLApp : public TOpenGLApp {
  public:
    // constructor
    CubeGLApp(void);

    // destructor
    ~CubeGLApp(void);

    // explicit initialization
    void explicitInitialize(void);

    // callback-functions
    void displayFunc(void);
    void keyboardFunc(unsigned char key, int x, int y);
    void idleFunc(void);

  private:
    // data-members
    typedef vector<RGBApixmap*> Textures;
    bool        fUseTICOTextures;
    double      fAngleIncrement;
    double      fAngle;
    Textures    fTICOTextures;
    RGBApixmap* fEscherTexture;
};

#endif
