      Vector3D side1 = Vector3D(fVertices[fTriangulatedFaces[i].fVertices[1].fVertexIndex]) -
                       Vector3D(fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex]);
      Vector3D side2 = Vector3D(fVertices[fTriangulatedFaces[i].fVertices[2].fVertexIndex]) -
                       Vector3D(fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex]);
      Vector3D normal = side1.outer(side2);

      double denominator = normal.inner(genericRay.fDirection);
      if (Math::abs(denominator) < Math::kEpsilon) {
        // ray is parallel to the triangle's plane
        continue;
      }

      // the triangle's plane is defined as N.S + d = 0
      // with N the normal to the plane and S the startpoint of the generic ray
      double d = -(Vector3D(fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex]).inner(normal));
      double numerator = -(normal.inner(genericRay.fStart) + d);

      double hitTime = numerator / denominator;

      Point3D p(Transformations::calcRayPosition(genericRay,hitTime));

      double u0, u1, v0, v1, u2, v2;
      Vector3D absNormal(Math::abs(normal.fX),Math::abs(normal.fY),Math::abs(normal.fZ));

      if (((absNormal.fY <= absNormal.fZ) &&
           (absNormal.fZ <= absNormal.fX)) ||
          ((absNormal.fZ <= absNormal.fY) &&
           (absNormal.fY <= absNormal.fX))) {
        u0 = p.fY - fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex].fY;
        v0 = p.fZ - fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex].fZ;
        u1 = fVertices[fTriangulatedFaces[i].fVertices[1].fVertexIndex].fY -
             fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex].fY;
        v1 = fVertices[fTriangulatedFaces[i].fVertices[1].fVertexIndex].fZ -
             fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex].fZ;
        u2 = fVertices[fTriangulatedFaces[i].fVertices[2].fVertexIndex].fY -
             fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex].fY;
        v2 = fVertices[fTriangulatedFaces[i].fVertices[2].fVertexIndex].fZ -
             fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex].fZ;
      }
      else if (((absNormal.fX <= absNormal.fZ) &&
                (absNormal.fZ <= absNormal.fY)) ||
               ((absNormal.fZ <= absNormal.fX) &&
                (absNormal.fX <= absNormal.fY))) {
        u0 = p.fZ - fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex].fZ;
        v0 = p.fX - fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex].fX;
        u1 = fVertices[fTriangulatedFaces[i].fVertices[1].fVertexIndex].fZ -
             fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex].fZ;
        v1 = fVertices[fTriangulatedFaces[i].fVertices[1].fVertexIndex].fX -
             fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex].fX;
        u2 = fVertices[fTriangulatedFaces[i].fVertices[2].fVertexIndex].fZ -
             fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex].fZ;
        v2 = fVertices[fTriangulatedFaces[i].fVertices[2].fVertexIndex].fX -
             fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex].fX;
      }
      else {
        u0 = p.fX - fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex].fX;
        v0 = p.fY - fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex].fY;
        u1 = fVertices[fTriangulatedFaces[i].fVertices[1].fVertexIndex].fX -
             fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex].fX;
        v1 = fVertices[fTriangulatedFaces[i].fVertices[1].fVertexIndex].fY -
             fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex].fY;
        u2 = fVertices[fTriangulatedFaces[i].fVertices[2].fVertexIndex].fX -
             fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex].fX;
        v2 = fVertices[fTriangulatedFaces[i].fVertices[2].fVertexIndex].fY -
             fVertices[fTriangulatedFaces[i].fVertices[0].fVertexIndex].fY;
      }

      bool intersected = false;
      double u, v;

      if (Math::abs(u1) < Math::kEpsilon) {
        v = u0 / u2;
        if ((v >= 0.0) &&
            (v <= 1.0)) {
          u = (v0 - (v * v2)) / v1;
          intersected = ((u >= 0.0) && ((u + v) <= 1.0));
        }
      }
      else {
        v = ((v0 * u1) - (u0 * v1)) / ((v2 * u1) - (u2 * v1));
        if ((v >= 0.0) &&
            (v <= 1.0)) {
          u = (u0 - (v * u2)) / u1;
          intersected = ((u >= 0.0) && ((u + v) <= 1.0));
        }
      }

      if (!intersected) {
        continue;
      }
