// ------------------------------
// Filename      : jitter.h
// Author        : Sven Maerivoet
// Last modified : 05/03/2001
// Target        : C++ (OpenGL)
//
// All rights reserved.
// ------------------------------

#ifndef SM_JITTER_H // include-guard
#define SM_JITTER_H

#ifdef _WIN32
  #include <windows.h>
#endif

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <vector>

using namespace std;

class JitterVector {
  public:
    // constructors
    JitterVector(void);
    JitterVector(double jvX, double jvY);

    // destructor
    ~JitterVector(void);

    // data-members
    double x, y;
};

class JitterVectors {
  public:
    // constructor
    JitterVectors(int nrOfJitterVectors);

    // destructor
    ~JitterVectors(void);

    // methods
    double getX(int jitterVector) const;
    double getY(int jitterVector) const;

  private:
    // data-members
    vector<JitterVector> fJitterVectors;
};

#endif
