// ------------------------------
// Filename      : sdlviewer.h
// Author        : Sven Maerivoet
// Last modified : 30/05/2001
// Target        : C++ (OpenGL)
//
// All rights reserved.
// ------------------------------

#ifndef SM_SDLVIEWER_H // include-guard
#define SM_SDLVIEWER_H

#include "opengl/opengl.h"
#include <string.h>

using namespace std;

class SDLViewerGLApp : public TOpenGLApp {
  public:
    // constructor
    SDLViewerGLApp(string filename);

    // destructor
    ~SDLViewerGLApp(void);

    // explicit initialization
    void explicitInitialize(void);

    // callback-functions
    void displayFunc(void);
    void keyboardFunc(unsigned char key, int x, int y);

  private:
    // data-members
    string                 fFilename;
    bool                   fEnableRayTracing;
    int                    fBlockSize;
    bool                   fComputeShadows;
    EShadowComputationMode fShadowComputationMode;
    int                    fNrOfConeSamples;
    bool                   fAntiAlias;
    EAntiAliasMode         fAntiAliasMode;
    bool                   fUseStochasticSampling;
    bool                   fNormalizeColors;
    double                 fNormalizeBrightness;
    bool                   fShowCoordinates;
    bool                   fFindNormals;
    bool                   fFollowRays;
};

#endif
